﻿Public Class Form1
    ' Define the Order structure.
    Private Structure Order
        Public OrderId As Integer
        Public Priority As Integer
    End Structure

    ' Sort some orders.
    Private Sub SortOrders(ByVal orders() As Order)
        ' Sanity checks.
        If (orders Is Nothing) Then
            Throw New ArgumentOutOfRangeException("orders",
                "SortOrders method: orders parameter must not be Nothing.")
        End If
        If (orders.Length < 1) Then
            Throw New ArgumentOutOfRangeException("orders",
                "SortOrders method cannot sort orders for an empty array.")
        End If
        Debug.Assert(orders.Length < 10000, "Too many orders.")

        ' Sort the orders here...


        ' Validate the result.
        For i As Integer = 1 To orders.Length - 1
            ' Make sure adjacent items are sorted.
            Debug.Assert(orders(i).Priority >= orders(i - 1).Priority,
                "Orders not correctly sorted.")
        Next i
    End Sub
End Class
