﻿Public Class Form1
    ' Convert from Fahrenheit.
    Private Sub btnFahrenheit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFahrenheit.Click
        Try
            Dim f As Double = Double.Parse(txtFahrenheit.Text)
            Dim c As Double = FahrenheitToCelsius(f)
            Dim k As Double = CelsiusToKelvin(c)

            txtFahrenheit.Text = f.ToString("0.00")
            txtCelsius.Text = c.ToString("0.00")
            txtKelvin.Text = k.ToString("0.00")
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' Convert from Celsius.
    Private Sub btnCelsius_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCelsius.Click
        Try
            Dim c As Double = Double.Parse(txtCelsius.Text)
            Dim f As Double = CelsiusToFahrenheit(c)
            Dim k As Double = CelsiusToKelvin(c)

            txtFahrenheit.Text = f.ToString("0.00")
            txtCelsius.Text = c.ToString("0.00")
            txtKelvin.Text = k.ToString("0.00")
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' Convert from Kelvin.
    Private Sub btnKelvin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKelvin.Click
        Try
            Dim k As Double = Double.Parse(txtKelvin.Text)
            Dim c As Double = KelvinToCelsius(k)
            Dim f As Double = CelsiusToFahrenheit(c)

            txtFahrenheit.Text = f.ToString("0.00")
            txtCelsius.Text = c.ToString("0.00")
            txtKelvin.Text = k.ToString("0.00")
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' Conversion functions.
    ' To Celsius functions.
    Private Function FahrenheitToCelsius(ByVal f As Double) As Double
        Debug.Assert((f >= -130) AndAlso (f <= 140),
            "Degrees Fahrenheit should be between -130 and 140.")
        Return (f - 32) * 5 / 9
    End Function

    Private Function KelvinToCelsius(ByVal k As Double) As Double
        Debug.Assert((k >= 183) AndAlso (k <= 333),
            "Degrees Kelvin should be between 183 and 333.")
        Return k - 273.15
    End Function


    ' From Celsius functions.
    Private Function CelsiusToFahrenheit(ByVal c As Double) As Double
        Debug.Assert((c >= -90) AndAlso (c <= 60),
            "Degrees Celsius should be between -90 and 60.")
        Return c * 9 / 5 + 32
    End Function

    Private Function CelsiusToKelvin(ByVal c As Double) As Double
        Debug.Assert((c >= -90) AndAlso (c <= 60),
            "Degrees Celsius should be between -90 and 60.")
        Return c + 273.15
    End Function
End Class
