﻿Public Class Form1
    ' Calculate and display the average salary.
    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        Try
            ' Copy the salaries into an array.
            Dim string_salaries() As String = txtSalaries.Text.Split()
            Dim salaries(0 To string_salaries.Length - 1) As Decimal
            For i As Integer = 0 To string_salaries.Length - 1
                salaries(i) = Decimal.Parse(string_salaries(i),
                    System.Globalization.NumberStyles.Any)
            Next i

            ' Calculate the average.
            Dim average As Decimal = AverageSalary(salaries)

            ' Test cases.
            'AverageSalary(New Decimal() {}) ' Empty array.
            'AverageSalary(Nothing)          ' Nothing.

            ' Display the result.
            txtAverage.Text = average.ToString("C")
        Catch ex As Exception
            txtAverage.Clear()
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' Calculate the average of this array of salaries.
    Private Function AverageSalary(ByVal salaries() As Decimal) As Decimal
        ' Sanity checks.
        If salaries Is Nothing Then
            Throw New ArgumentOutOfRangeException("salaries",
                "AverageSalary function: salaries parameter " &
                "must not be Nothing")
        End If
        If (salaries.Length < 1) Then
            Throw New ArgumentOutOfRangeException("salaries",
                "AverageSalary function cannot calculate average " &
                "salary for an empty array.")
        End If
        Debug.Assert(salaries.Length < 100, "Too many salaries.")
        For i As Integer = 0 To salaries.Length - 1
            Debug.Assert(salaries(i) >= 10000, "Salary is too small.")
            Debug.Assert(salaries(i) < 1000000, "Salary is too big.")
        Next i

        ' Calculate the result.
        Dim total As Decimal = 0
        For Each salary In salaries
            total += salary
        Next salary
        Dim result As Decimal = total / salaries.Length

        ' Validate the result.
        Debug.Assert(result >= 10000, "Average salary is too small.")
        Debug.Assert(result < 1000000, "Average salary is too big.")

        Return result
    End Function
End Class
